Attribute VB_Name = "OtxWrapper"
Option Explicit

Public Const OTX_S_OK As Long = 0
Public Const OTX_TASK_SYNC As Long = 0
Public Const OTX_INVALID_HANDLE_VALUE As Long = -1

Public Enum OtxPhysicalDeviceTypeE
  OTX_DEVICE_UNKNOWN = 0
  OTX_DEVICE_DRIVER = 1
  OTX_DEVICE_ARNI_PCI = 2
  OTX_DEVICE_BALDER_PCMCIA = 3
  OTX_DEVICE_BALDER_S_PCI = 4
  OTX_DEVICE_BALDER_U_PCI = 5
  OTX_DEVICE_THOR_PCI = 6
  OTX_DEVICE_THOR_PCMCIA = 7
  OTX_DEVICE_VIDAR_5x_PCI = 8
  OTX_DEVICE_VIDAR_6x_PCI = 9
  OTX_DEVICE_SIF_PCI = 10
  OTX_DEVICE_VIDAR_5x_ASM = 11
  OTX_DEVICE_VIDAR_6x_ASM = 12
  OTX_DEVICE_VIDAR_55x4_ASM = 13
  OTX_DEVICE_LI_CONTROLLER = 14
  OTX_DEVICE_LI_POTS = 15
  OTX_DEVICE_LI_SLIC = 16
  OTX_DEVICE_LI_T1E1 = 17
  OTX_DEVICE_LI_BRI_S = 18
  OTX_DEVICE_LI_BRI_U = 19
  OTX_DEVICE_HDLC = 20
  OTX_DEVICE_TSS = 21
  OTX_DEVICE_DSP = 22
  OTX_DEVICE_PROCESSOR = 23
  OTX_DEVICE_PCI_BRIDGE = 24
  OTX_DEVICE_CODEC = 25
  OTX_DEVICE_EEPROM = 26
  OTX_DEVICE_TBC = 27
  OTX_DEVICE_QUAD_T1E1 = 28
  OTX_DEVICE_QUAD_CODEC = 29
  OTX_DEVICE_THOR_8_PCI = 30
  OTX_DEVICE_CT_BUS = 31
  OTX_DEVICE_HERMOD_PCI = 32
  OTX_DEVICE_GIMLE_16_PCI = 33
  OTX_DEVICE_VIDAR_5X1_ASM_BASIC = 34
  OTX_DEVICE_THOR_1_PCI_BASIC = 35
  OTX_DEVICE_VIDAR_5X4_ASM_CST = 36
  OTX_DEVICE_VIDAR_5X4_ASM_V90 = 37
  OTX_DEVICE_VIDAR_5X4_ASM_EX = 38
  OTX_DEVICE_THOR_8_PCI_PLUS = 39
  OTX_DEVICE_THOR_2_PCI_PLUS = 40
  OTX_DEVICE_SLEIPNIR_1_PCI = 41
  OTX_DEVICE_VIDAR_55X12_PCI = 42
  OTX_DEVICE_BURST = 43
  OTX_DEVICE_VIDAR_5X4_ASM_PRO = 44
  OTX_DEVICE_END = 45
End Enum

Enum OtxCommonDeviceAttributesE
  OTX_ATTR_DEVICE_HOST = 0
  OTX_ATTR_DEVICE_NIC = 1
  OTX_ATTR_DEVICE_TYPE = 2
  OTX_ATTR_DEVICE_NO = 3
  OTX_ATTR_DEVICE_IRP_QUEUE_LIMIT = 4
  OTX_ATTR_DEVICE_IRP_QUEUE_SIZE = 5
  OTX_ATTR_DEVICE_SYNC_ENABLE = 6
  OTX_ATTR_DEVICE_SYNC_DISABLE = 7
  OTX_ATTR_END = 8
End Enum

Enum OtxBoardDeviceAttributesE
  OTX_ATTR_BRD_SERIAL_NUMBER = OTX_ATTR_END + 0
  OTX_ATTR_BRD_BUILD = OTX_ATTR_END + 1
  OTX_ATTR_BRD_CIS_REV = OTX_ATTR_END + 2
  OTX_ATTR_BRD_CPLD_BUILD = OTX_ATTR_END + 3
  OTX_ATTR_BRD_BUS_ADDRESS = OTX_ATTR_END + 4
  OTX_ATTR_BRD_PCMCIA_SOCKET_NUMBER = OTX_ATTR_END + 5
  OTX_ATTR_BRD_PCI_DEVICE_NUMBER = OTX_ATTR_END + 6
  OTX_ATTR_BRD_PCI_FUNCTION_NUMBER = OTX_ATTR_END + 7
  OTX_ATTR_BRD_USER_STRING = OTX_ATTR_END + 8
  OTX_ATTR_BRD_PCMCIA_DONGLE_TYPE = OTX_ATTR_END + 9
  OTX_ATTR_BRD_DPC_MAX_TIMESLICE = OTX_ATTR_END + 10
  OTX_ATTR_BRD_PNP_ID = OTX_ATTR_END + 11
  OTX_ATTR_BRD_PCMCIA_AMP_DONGLE_0 = OTX_ATTR_END + 12
  OTX_ATTR_BRD_PCMCIA_AMP_DONGLE_1 = OTX_ATTR_END + 13
  OTX_ATTR_BRD_DEVICE_ID = OTX_ATTR_END + 14
  OTX_ATTR_BRD_SUBSYSTEM_ID = OTX_ATTR_END + 15
  OTX_ATTR_BRD_DSP_PORTS_DISABLED = OTX_ATTR_END + 16
  OTX_ATTR_BRD_LED_OVERRIDE = OTX_ATTR_END + 17
  OTX_ATTR_BRD_LED_COUNT = OTX_ATTR_END + 18
  OTX_ATTR_BRD_LED_STATE = OTX_ATTR_END + 19
  OTX_ATTR_BRD_DSP_SOURCED = OTX_ATTR_END + 20
  OTX_ATTR_BRD_FALC_SOURCED = OTX_ATTR_END + 21
  OTX_ATTR_BRD_S2P_SOURCED = OTX_ATTR_END + 22
  OTX_ATTR_BRD_END = OTX_ATTR_END + 23
End Enum

Public Enum OtxE1LineCodeE
    OTX_E1_LC_AMI = &H0&
    OTX_E1_LC_HDB3 = &H1&
End Enum

Public Enum OtxE1FrameFormatE
    OTX_E1_FF_DOUBLE_FRAME = &H0&
    OTX_E1_FF_CRC4_MULTIFRAME = &H1&
    OTX_E1_FF_CRC4_MULTIFRAME_G706 = &H2&
End Enum

Public Enum OtxE1AisDetectModeE
    OTX_E1_AIS_ETS300233 = &H0&
    OTX_E1_AIS_G775 = &H1&
End Enum

Type OtxE1ConfigOptionsS
    eTxLineCode                 As OtxE1LineCodeE
    eRxLineCode                 As OtxE1LineCodeE
    eTxFrameFormat              As OtxE1FrameFormatE
    eRxFrameFormat              As OtxE1FrameFormatE
    eAisDetection               As OtxE1AisDetectModeE
    bfSiBits                    As Byte
    bfSaBits                    As Byte
    bExtendedHDB3errorDetect    As Byte
    bAutoRegainMultiframe       As Byte
    bAutoResync                 As Byte
    bAutoCrcBitInversion        As Byte
    bAutoRemoteAlarm            As Byte
    nLosSensitivity             As Byte
    nLosRecovery                As Byte
    nLineLength                 As Integer
    bHighTxPower                As Byte
    bReceiveEqualizer           As Byte
End Type

' these are direct interfaces to the OTX SDK interface (OtxHwDll.dll) (available as of release P-141)
Declare Function OtxDrvConnectLib Lib "OtxHwDll" () As Long
Declare Function OtxDrvReleaseLib Lib "OtxHwDll" () As Long
Declare Function OtxDrvIteratorBegin Lib "OtxHwDll" (ByRef pItr As Long) As Long
Declare Function OtxDrvIteratorEnd Lib "OtxHwDll" (ByRef pItr As Long) As Long
Declare Function OtxDrvGetAttributeValueUint32 Lib "OtxHwDll" (ByVal hDevice As Long, ByVal nAttribId As Long, ByRef pAttribValue As Long) As Long
Declare Function OtxDrvEnumDeviceType Lib "OtxHwDll" (ByVal hDevice As Long, ByRef pItr As Long, ByRef peDeviceType As OtxPhysicalDeviceTypeE) As Long
Declare Function OtxDrvEnumDevice Lib "OtxHwDll" (ByVal hDevice As Long, ByVal eDeviceType As Long, ByRef pItr As Long, ByRef phChildDevice As Long) As Long
Declare Function OtxDrvCreateEvent Lib "OtxHwDll" (ByRef phEvent As Long) As Long
Declare Function OtxDrvCreateEventQueue Lib "OtxHwDll" (ByVal nSize As Long, ByVal hEvent As Long, ByRef phEventQueue As Long) As Long
Declare Function OtxDrvEnable Lib "OtxHwDll" (ByVal hObject As Long, ByVal nTaskRef As Long, ByVal nWaitMaxMs As Long) As Long
Declare Function OtxDrvOpenPhysicalDevice Lib "OtxHwDll" (ByVal hHostDevice As Long, ByVal eDevType As Long, ByVal nDevice As Long, ByVal nEventSourceId As Long, ByVal hEventQueue As Long, ByRef phPhysDevice As Long) As Long
Declare Function OtxDrvClose Lib "OtxHwDll" (ByVal hDevice As Long) As Long

' these are interfaces to the sample OTX Wrapper interface
Declare Function WrapOtxDrvConnectLib Lib "OtxWrapper" () As Long
Declare Function WrapOtxDrvReleaseLib Lib "OtxWrapper" () As Long
Declare Function WrapOtxDrvIteratorBegin Lib "OtxWrapper" (ByRef pItr As Long) As Long
Declare Function WrapOtxDrvIteratorEnd Lib "OtxWrapper" (ByRef pItr As Long) As Long
Declare Function WrapOtxDrvGetAttributeValueUint32 Lib "OtxWrapper" (ByVal hDevice As Long, ByVal nAttribId As Long, ByRef pAttribValue As Long) As Long
Declare Function GetOtxDrvGetAttributeValueUint32 Lib "OtxWrapper" (ByVal hDevice As Long, ByVal nAttribId As Long) As Long
Declare Function WrapOtxDrvEnumDeviceType Lib "OtxWrapper" (ByVal hDevice As Long, ByRef pItr As Long, ByRef peDeviceType As OtxPhysicalDeviceTypeE) As Long
Declare Function WrapOtxDrvEnumDevice Lib "OtxWrapper" (ByVal hDevice As Long, ByVal eDeviceType As Long, ByRef pItr As Long, ByRef phChildDevice As Long) As Long
Declare Function WrapOtxDrvCreateEvent Lib "OtxWrapper" (ByRef phEvent As Long) As Long
Declare Function WrapOtxDrvCreateEventQueue Lib "OtxWrapper" (ByVal nSize As Long, ByVal hEvent As Long, ByRef phEventQueue As Long) As Long
Declare Function WrapOtxDrvEnable Lib "OtxWrapper" (ByVal hObject As Long, ByVal nTaskRef As Long, ByVal nWaitMaxMs As Long) As Long
Declare Function WrapOtxDrvOpenPhysicalDevice Lib "OtxWrapper" (ByVal hHostDevice As Long, ByVal eDevType As Long, ByVal nDevice As Long, ByVal nEventSourceId As Long, ByVal hEventQueue As Long, ByRef phPhysDevice As Long) As Long
Declare Function WrapOtxDrvClose Lib "OtxWrapper" (ByVal hDevice As Long) As Long

Declare Function WrapOtxE1SetConfiguration Lib "OtxWrapper" ( _
    ByVal hLineDevice As Long, _
    ByVal eTxLineCode As Long, _
    ByVal eRxLineCode As Long, _
    ByVal eTxFrameFormat As Long, _
    ByVal eRxFrameFormat As Long, _
    ByVal eAisDetection As Long, _
    ByVal bfSiBits As Byte, _
    ByVal bfSaBits As Byte, _
    ByVal bExtendedHDB3errorDetect As Byte, _
    ByVal bAutoRegainMultiframe As Byte, _
    ByVal bAutoResync As Byte, _
    ByVal bAutoCrcBitInversion As Byte, _
    ByVal bAutoRemoteAlarm As Byte, _
    ByVal nLosSensitivity As Byte, _
    ByVal nLosRecovery As Byte, _
    ByVal nLineLength As Integer, _
    ByVal bHighTxPower As Byte, _
    ByVal bReceiveEqualizer As Byte _
    ) As Long

Declare Function WrapOtxE1GetConfiguration Lib "OtxWrapper" ( _
    ByVal hLineDevice As Long, _
    ByRef eTxLineCode As Long, _
    ByRef eRxLineCode As Long, _
    ByRef eTxFrameFormat As Long, _
    ByRef eRxFrameFormat As Long, _
    ByRef eAisDetection As Long, _
    ByRef bfSiBits As Byte, _
    ByRef bfSaBits As Byte, _
    ByRef bExtendedHDB3errorDetect As Byte, _
    ByRef bAutoRegainMultiframe As Byte, _
    ByRef bAutoResync As Byte, _
    ByRef bAutoCrcBitInversion As Byte, _
    ByRef bAutoRemoteAlarm As Byte, _
    ByRef nLosSensitivity As Byte, _
    ByRef nLosRecovery As Byte, _
    ByRef nLineLength As Integer, _
    ByRef bHighTxPower As Byte, _
    ByRef bReceiveEqualizer As Byte _
    ) As Long

Declare Function SetE1Configuration Lib "OtxWrapper" (ByVal hLineDevice) As Long
Declare Sub SubSetE1_eTxLineCode Lib "OtxWrapper" (ByVal eTxLineCode)
Declare Sub SetE1_eRxLineCode Lib "OtxWrapper" (ByVal eRxLineCode)
Declare Sub SetE1_eTxFrameFormat Lib "OtxWrapper" (ByVal eTxFrameFormat)
Declare Sub SetE1_eRxFrameFormat Lib "OtxWrapper" (ByVal eRxFrameFormat)
Declare Sub SetE1_eAisDetection Lib "OtxWrapper" (ByVal eAisDetection)
Declare Sub SetE1_bfSiBits Lib "OtxWrapper" (ByVal bfSiBits)
Declare Sub SetE1_bfSaBits Lib "OtxWrapper" (ByVal bfSaBits)
Declare Sub SetE1_bExtendedHDB3errorDetect Lib "OtxWrapper" (ByVal bExtendedHDB3errorDetect)
Declare Sub SetE1_bAutoRegainMultiframe Lib "OtxWrapper" (ByVal bAutoRegainMultiframe)
Declare Sub SetE1_bAutoResync Lib "OtxWrapper" (ByVal bAutoResync)
Declare Sub SetE1_bAutoCrcBitInversion Lib "OtxWrapper" (ByVal bAutoCrcBitInversion)
Declare Sub SetE1_bAutoRemoteAlarm Lib "OtxWrapper" (ByVal bAutoRemoteAlarm)
Declare Sub SetE1_nLosSensitivity Lib "OtxWrapper" (ByVal nLosSensitivity)
Declare Sub SetE1_nLosRecovery Lib "OtxWrapper" (ByVal nLosRecovery)
Declare Sub SetE1_nLineLength Lib "OtxWrapper" (ByVal nLineLength)
Declare Sub SetE1_bHighTxPower Lib "OtxWrapper" (ByVal bHighTxPower)
Declare Sub SetE1_bReceiveEqualizer Lib "OtxWrapper" (ByVal bReceiveEqualizer)
                                                                                                
Declare Function GetE1Configuration Lib "OtxWrapper" (ByVal hLineDevice As Long) As Long
Declare Function GetE1_eTxLineCode Lib "OtxWrapper" (ByRef eTxLineCode As OtxE1LineCodeE) As Long
Declare Function GetE1_eRxLineCode Lib "OtxWrapper" (ByRef eRxLineCode As OtxE1LineCodeE) As Long
Declare Function GetE1_eTxFrameFormat Lib "OtxWrapper" (ByRef eTxFrameFormat As OtxE1FrameFormatE) As Long
Declare Function GetE1_eRxFrameFormat Lib "OtxWrapper" (ByRef eRxFrameFormat As OtxE1FrameFormatE) As Long
Declare Function GetE1_eAisDetection Lib "OtxWrapper" (ByRef eAisDetection As OtxE1AisDetectModeE) As Long
Declare Function GetE1_bfSiBits Lib "OtxWrapper" (ByRef bfSiBits As Byte) As Long
Declare Function GetE1_bfSaBits Lib "OtxWrapper" (ByRef bfSaBits As Byte) As Long
Declare Function GetE1_bExtendedHDB3errorDetect Lib "OtxWrapper" (ByRef bExtendedHDB3errorDetect As Byte) As Long
Declare Function GetE1_bAutoRegainMultiframe Lib "OtxWrapper" (ByRef bAutoRegainMultiframe As Byte) As Long
Declare Function GetE1_bAutoResync Lib "OtxWrapper" (ByRef bAutoResync As Byte) As Long
Declare Function GetE1_bAutoCrcBitInversion Lib "OtxWrapper" (ByRef bAutoCrcBitInversion As Byte) As Long
Declare Function GetE1_bAutoRemoteAlarm Lib "OtxWrapper" (ByRef bAutoRemoteAlarm As Byte) As Long
Declare Function GetE1_nLosSensitivity Lib "OtxWrapper" (ByRef nLosSensitivity As Byte) As Long
Declare Function GetE1_nLosRecovery Lib "OtxWrapper" (ByRef nLosRecovery As Byte) As Long
Declare Function GetE1_nLineLength Lib "OtxWrapper" (ByRef nLineLength As Integer) As Long
Declare Function GetE1_bHighTxPower Lib "OtxWrapper" (ByRef bHighTxPower As Byte) As Long
Declare Function GetE1_bReceiveEqualizer Lib "OtxWrapper" (ByRef bReceiveEqualizer As Byte) As Long
Declare Function RetE1_eTxLineCode Lib "OtxWrapper" () As OtxE1LineCodeE
Declare Function RetE1_eRxLineCode Lib "OtxWrapper" () As OtxE1LineCodeE
Declare Function RetE1_eTxFrameFormat Lib "OtxWrapper" () As OtxE1FrameFormatE
Declare Function RetE1_eRxFrameFormat Lib "OtxWrapper" () As OtxE1FrameFormatE
Declare Function RetE1_eAisDetection Lib "OtxWrapper" () As OtxE1AisDetectModeE
Declare Function RetE1_bfSiBits Lib "OtxWrapper" () As Byte
Declare Function RetE1_bfSaBits Lib "OtxWrapper" () As Byte
Declare Function RetE1_bExtendedHDB3errorDetect Lib "OtxWrapper" () As Byte
Declare Function RetE1_bAutoRegainMultiframe Lib "OtxWrapper" () As Byte
Declare Function RetE1_bAutoResync Lib "OtxWrapper" () As Byte
Declare Function RetE1_bAutoCrcBitInversion Lib "OtxWrapper" () As Byte
Declare Function RetE1_bAutoRemoteAlarm Lib "OtxWrapper" () As Byte
Declare Function RetE1_nLosSensitivity Lib "OtxWrapper" () As Byte
Declare Function RetE1_nLosRecovery Lib "OtxWrapper" () As Byte
Declare Function RetE1_nLineLength Lib "OtxWrapper" () As Integer
Declare Function RetE1_bHighTxPower Lib "OtxWrapper" () As Byte
Declare Function RetE1_bReceiveEqualizer Lib "OtxWrapper" () As Byte

Public Function SHL(ByVal inVal As Long, ByVal inShift As Byte) As Long
    SHL = inVal * (2 ^ inShift) ' Bit shift left
End Function

Public Function SHR(ByVal inVal As Long, ByVal inShift As Byte) As Long
    SHR = inVal / (2 ^ inShift) ' Bit shift right
End Function

Public Function OTX_SUCCESS(ByVal status As Long) As Boolean
    If status >= 0 Then
        OTX_SUCCESS = True
    Else
        OTX_SUCCESS = False
    End If
End Function

Public Function OTX_RESULT_CODE(ByVal ores As Long) As Long
    OTX_RESULT_CODE = (ores And &H800000FF)    '((OTX_RESULT)((ores) & 0x800000ff))
End Function

Public Function OTX_RESULT_SOURCE_ID(ByVal ores As Long) As Long
    OTX_RESULT_SOURCE_ID = (SHR(ores, 23) And &HFF)  '(((ores) >> 23) & 0xff)
End Function

Public Function OTX_RESULT_LINE_NUM(ByVal ores As Long) As Long
    OTX_RESULT_LINE_NUM = (SHR(ores, 8) And &H7FFF)      '(((ores) >>  8) & 0x7fff)
End Function

Public Function sOtxE1AisDetectModeE(OtxE1AisDetectMode As OtxE1AisDetectModeE) As String
    If OtxE1AisDetectMode = OTX_E1_AIS_ETS300233 Then
        sOtxE1AisDetectModeE = "ETS300233"
    ElseIf OtxE1AisDetectMode = OTX_E1_AIS_G775 Then
        sOtxE1AisDetectModeE = "G775"
    Else
        sOtxE1AisDetectModeE = ""
    End If
End Function

Public Function sOtxE1FrameFormatE(OtxE1FrameFormat As OtxE1FrameFormatE) As String
    If OtxE1FrameFormat = OTX_E1_FF_DOUBLE_FRAME Then
        sOtxE1FrameFormatE = "DOUBLE FRAME"
    ElseIf OtxE1FrameFormat = OTX_E1_FF_CRC4_MULTIFRAME Then
        sOtxE1FrameFormatE = "CRC4 MULTIFRAME"
    ElseIf OtxE1FrameFormat = OTX_E1_FF_CRC4_MULTIFRAME_G706 Then
        sOtxE1FrameFormatE = "CRC4 MULTIFRAME G706"
    Else
        sOtxE1FrameFormatE = ""
    End If
End Function

Public Function sOtxE1LineCodeE(OtxE1LineCode As OtxE1LineCodeE) As String
    If OtxE1LineCode = OTX_E1_LC_AMI Then
        sOtxE1LineCodeE = "AMI"
    ElseIf OtxE1LineCode = OTX_E1_LC_HDB3 Then
        sOtxE1LineCodeE = "HDB3"
    Else
        sOtxE1LineCodeE = ""
    End If
End Function
